﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Diagnostics;
using System.Text;

namespace HDRecHelper
{
    class Program
    {
        static String results;

        static void Main(string[] args)
        {
            String HOME = System.AppDomain.CurrentDomain.BaseDirectory;
            StreamReader inistream;
            String drv_letter = "E:";
            String work_dir = String.Empty;
            char[] seplator = { ' ', '\t', '\r', '\n' };
            String target_name;
            String line;

            Directory.SetCurrentDirectory(HOME);
            if (File.Exists(HOME + "HDRecHelper.ini"))
            {
                try
                {
                    inistream = File.OpenText(HOME + "HDRecHelper.ini");
                    while ((line = inistream.ReadLine()) != null)
                    {
                        if (line.Contains("DRIVE_LETTER:"))
                        {
                            String[] drv_line = line.Split(seplator);
                            drv_letter = drv_line[1];
                        }
                        if (line.Contains("WORK_DIR:"))
                        {
                            work_dir = line.Substring("WORK_DIR:".Length);
                        }
                    }
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.Message);
                    System.Threading.Thread.Sleep(2000);
                    return;
                }
            }

            if (work_dir != String.Empty)
            {
                if (Directory.Exists(work_dir))
                {
                    Directory.SetCurrentDirectory(work_dir);
                }
                else
                {
                    try
                    {
                        Directory.CreateDirectory(work_dir);
                    }
                    catch (Exception e)
                    {
                        Console.WriteLine(e.Message);
                        System.Threading.Thread.Sleep(2000);
                        return;
                    }
                    Directory.SetCurrentDirectory(work_dir);
                }
            }
            LaunchApp(HOME + "tools\\HDRecGetTitleName.exe", String.Format("{0}\\DVD_HDVR\\HR_MANGR.IFO", drv_letter));
            target_name = results;
            Console.WriteLine(results);

            LaunchApp(HOME + "tools\\DVD_disk_Id.exe", drv_letter);

            //出力された結果を表示
            Console.WriteLine(results);

            String disk_result = results.Substring(results.IndexOf("disk_Id:"));
            String[] d_id = disk_result.Split(seplator);

            LaunchApp(HOME + "tools\\hddvd_vr_aacskeys.exe", String.Format("{0} 0000000000000000 {1}", drv_letter, d_id[1]));
            Console.WriteLine(results);
            //return;

            //ComSpecのパスを取得する
            String cmd_app = System.Environment.GetEnvironmentVariable("ComSpec");

            Console.WriteLine("Copying...");
            LaunchApp(cmd_app, String.Format("/c copy {0}\\DVD_HDVR\\HDVR_SOB\\HR_STR01.SRO", drv_letter));
            Console.WriteLine("Cpied");

            Console.WriteLine("Decrypting...");
            LaunchApp(HOME+"tools\\hddvd_vr_decrypt.exe", "");
            Console.WriteLine("Decrypted");

            //コマンドラインを指定（"/c"は実行後閉じるために必要）
            LaunchApp(cmd_app, "/c del HR_STR01.SRO");

            Console.WriteLine("cciconv...");
            LaunchApp(HOME+"tools\\cciconv192to188.exe", "free_HR_STR01.SRO free_HR_STR01.ts");
            Console.WriteLine("finish...");
            LaunchApp(cmd_app, "/c del *.SRO");
            LaunchApp(cmd_app, "/c del key.ini");
            try
            {
                File.Move("free_HR_STR01.ts", target_name+".ts");      //rename
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                System.Threading.Thread.Sleep(2000);
                return;
            }

        }

        static void LaunchApp(String AppName, String arg)
        {
            ProcessStartInfo psi = new ProcessStartInfo();

            psi.FileName = AppName;

            //出力を読み取れるようにする
            psi.RedirectStandardInput = false;
            psi.RedirectStandardOutput = true;
            psi.UseShellExecute = false;

            //ウィンドウを表示しないようにする
            psi.CreateNoWindow = true;

            psi.Arguments = arg;

            //起動
            System.Diagnostics.Process p = System.Diagnostics.Process.Start(psi);

            //出力を読み取る
            results = p.StandardOutput.ReadToEnd();
            //WaitForExitはReadToEndの後である必要がある
            //(親プロセス、子プロセスでブロック防止のため)
            p.WaitForExit(Int32.MaxValue);      //いつまでも待ちますよ～

        }
    }//-------------------------------
}
